%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% glsolve.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% function glsolve(probs, soldir)
%
% solve the selected problem or all the problems in a problem list or
% in a directory.
%
% probs         directory, where all .def problems should be solved or
%               .lst file with all problems to be solved.
% soldir        directory to store the solutions

function solve(probs, soldir)

currpath=pwd;
%solverpath='~/Projects/Gloptlab/';
solverpath='C:/Work/Matlab/Gloptlab/';

startp='';
sfile=[solverpath '/Strategies/solve.str'];
testenv=1;
if isunix, config=[solverpath 'Gloptlab_unix.cfg'];
else config=[solverpath 'Gloptlab_win.cfg'];
end
timeout=120;
outptime=15;
savetime=inf;
autosavedir=[];
prt=1;
log=0;
logdir=[];
pro=0;
proofdir=[];
stat=0;
statfile=[];
err=1;
cd(solverpath);
glsolve(probs, startp, sfile, soldir, testenv, config,...
    timeout, outptime, savetime, autosavedir, prt, log, logdir, pro, ...
    proofdir, stat, statfile, err)
cd(currpath);
