function varargout = gleditor_gui(varargin)
% GLEDITOR_GUI M-file for gleditor_gui.fig
%      GLEDITOR_GUI, by itself, creates a new GLEDITOR_GUI or raises the existing
%      singleton*.
%
%      H = GLEDITOR_GUI returns the handle to a new GLEDITOR_GUI or the handle to
%      the existing singleton*.
%
%      GLEDITOR_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GLEDITOR_GUI.M with the given input arguments.
%
%      GLEDITOR_GUI('Property','Value',...) creates a new GLEDITOR_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before gleditor_gui_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to gleditor_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help gleditor_gui

% Last Modified by GUIDE v2.5 14-Dec-2009 20:48:35

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gleditor_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @gleditor_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before gleditor_gui is made visible.
function gleditor_gui_OpeningFcn(hObject, eventdata, handles, varargin)
handles.path=[];
if nargin > 3
    for i=1:2:length(varargin)
        if strcmp(varargin{i},'Text')
            %text supplied
            txt=varargin{i+1};
            set(handles.editor_ET,'Max',max(length(txt),2),'String',txt);
        elseif strcmp(varargin{i},'OutputFile')
            %output filename supplied
            set(handles.file_ET,'String',varargin{i+1});
        elseif strcmp(varargin{i},'Path')
            handles.path=varargin{i+1};
        elseif strcmp(varargin{i},'InputFile')
            %input filename supplied, read file
            filen=[handles.path varargin{i+1}];
            if exist(filen,'file')==2,
                fid=fopen(filen);
                txt=cell(0);
                while 1
                    tline = fgetl(fid);
                    if ~ischar(tline), break, end
                    txt=[txt; {tline}];
                end
                fclose(fid);
                set(handles.editor_ET,'Max',max(length(txt),2),'String',txt);
            end
            set(handles.file_ET,'String',filen);
        elseif strcmp(varargin{i},'Filename')
            %filename supplied (do not load the file)
            set(handles.file_ET,'String',varargin{i+1});
        elseif strcmp(varargin{i},'Edit')
            if strcmp(varargin{i+1},'off')
                set(handles.save_PB,'Enable','off');
                set(handles.save_exit_PB,'Enable','off');
                set(handles.file_ET,'Enable','inactive');
            end
        elseif strcmp(varargin{i},'FontSize')
            set(handles.editor_ET,'FontSize', varargin{i+1});
        end
    end
end
handles.output = [];
% set the gui position
glsetguipos(hObject, 'lr', 'l+0.01', 'r-0.01');
guidata(hObject, handles);
set(handles.figure1,'WindowStyle','modal')
uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = gleditor_gui_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.output;
guidata(hObject, handles);
delete(handles.figure1);

% --- Executes when user attempts to close gleditor_gui.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
if ~isfield(handles,'figure1')
    delete(hObject); return;
end

if isequal(get(handles.figure1, 'waitstatus'), 'waiting')
    % The GUI is still in UIWAIT, us UIRESUME
    uiresume(handles.figure1);
else
    % The GUI is no longer waiting, just close it
    delete(handles.figure1);
end

% --- Executes on button press in save_PB.
function save_PB_Callback(hObject, eventdata, handles)
handles=saveit(handles);
guidata(hObject, handles);

% --- Executes on button press in quit_PB.
function quit_PB_Callback(hObject, eventdata, handles)
uiresume(handles.figure1);

% --- Executes on button press in save_exit_PB.
function save_exit_PB_Callback(hObject, eventdata, handles)
handles=saveit(handles);
guidata(hObject, handles);
uiresume(handles.figure1);

function handles=saveit(handles)
filen=get(handles.file_ET,'String');
txt=get(handles.editor_ET,'String');
if ~iscell(txt), txt={txt}; end
fid=fopen(filen,'w');
for i=1:length(txt)
    fprintf(fid,'%s\n',txt{i});
end
fclose(fid);
handles.output=filen;


% --- Executes during object deletion, before destroying properties.
function figure1_DeleteFcn(hObject, eventdata, handles)
glsaveguipos(hObject);
