function varargout = glfileselect_gui(varargin)
% GLFILESELECT_GUI M-file for glfileselect_gui.fig
%      GLFILESELECT_GUI by itself, creates a new GLFILESELECT_GUI or raises the
%      existing singleton*.
%
%      H = GLFILESELECT_GUI returns the handle to a new GLFILESELECT_GUI or the handle to
%      the existing singleton*.
%
%      GLFILESELECT_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GLFILESELECT_GUI.M with the given input arguments.
%
%      GLFILESELECT_GUI('Property','Value',...) creates a new GLFILESELECT_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before glfileselect_gui_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to glfileselect_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help glfileselect_gui

% Last Modified by GUIDE v2.5 01-Oct-2005 10:12:39

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @glfileselect_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @glfileselect_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before glfileselect_gui is made visible.
function glfileselect_gui_OpeningFcn(hObject, eventdata, handles, varargin)
handles.path=cd;
handles.fmask={'*.*'};
handles.sdir='';
file='';
if nargin > 3
    for i=1:2:length(varargin)
        if strcmp(varargin{i},'Path')
            %path supplied
            if exist(varargin{i+1},'dir')==7,
                handles.path=varargin{i+1};
            end
        elseif strcmp(varargin{i},'Chdir')
            %sets if changing directory is allowed or not
            set(handles.dirs_LB,'Enable',varargin{i+1});
            set(handles.current_dir_ET,'Enable',varargin{i+1});
        elseif strcmp(varargin{i},'Filemask')
            %sets allowed file mask
            ext=varargin{i+1};
            ind=[0 find(ext==',') length(ext)+1];
            n=length(ind)-1;handles.fmask=cell(n,1);
            for j=1:n
                ex=ext(ind(j)+1:ind(j+1)-1);
                handles.fmask{j}=ex(ex~=' ');%remove spaces 
            end
        elseif strcmp(varargin{i},'File')
            %default selected file
            file=varargin{i+1};
        end
    end
end
%get directory listing
getdir(handles);
%set default selection
if ~isempty(file)
    fnames=get(handles.files_LB, 'String');
    for i=1:length(fnames)
        if strcmp(fnames{i},file)
            set(handles.files_LB, 'Value', i);
            break;
        end
    end
end
handles.output = [];
guidata(hObject, handles);
glsetguipos(hObject, 'ur', 'u', 'r-0.18');
set(handles.figure1,'WindowStyle','modal')
% UIWAIT makes glselecttask_gui wait for user response (see UIRESUME)
uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = glfileselect_gui_OutputFcn(hObject, eventdata, handles)
if isfield(handles,'output') 
    varargout{1} = handles.output;
    delete(handles.figure1);
else varargout{1} =[];
end

% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
if ~isfield(handles,'figure1')
    delete(hObject); return;
end

if isequal(get(handles.figure1, 'waitstatus'), 'waiting')
    uiresume(handles.figure1);
else
    delete(handles.figure1);
end
    
% --- Executes on key press over figure1 with no controls selected.
function figure1_KeyPressFcn(hObject, eventdata, handles)
uiresume(handles.figure1);

% --- Executes on button press in ok_PB.
function ok_PB_Callback(hObject, eventdata, handles)
    fnames=get(handles.files_LB, 'String');
    fname=fnames{get(handles.files_LB, 'Value')};
    cdir=get(handles.current_dir_ET, 'String');
    handles.output = [cdir fname];
    guidata(hObject, handles);
    uiresume(handles.figure1);

% --- Executes on button press in cancel_PB.
function cancel_PB_Callback(hObject, eventdata, handles)
uiresume(handles.figure1);

% --- Executes on selection change in dirs_LB.
function dirs_LB_Callback(hObject, eventdata, handles)
    dirs = get(hObject,'String');
    d=dirs{get(hObject,'Value')};
    if strcmp(d,handles.sdir);
        if strcmp(d,'..')
            ind=find(handles.path=='/');
            handles.path=handles.path(1:ind(end)-1);
        else
            handles.path=[handles.path '/' d];
        end
        handles.sdir='';
        getdir(handles);
    else
        handles.sdir=d;
    end
    % Update handles structure
    guidata(hObject, handles);

%get directory listing
function getdir(handles)
    d=handles.path;MAXDIRLEN=16;
    if length(d)>MAXDIRLEN && strcmp(get(handles.current_dir_ET, 'Enable'),'inactive'),
        d=['...' d(end-MAXDIRLEN:end)];
    end
    set(handles.current_dir_ET, 'String', d);
    direct=dir(handles.path);
    %get directory listing
    dirs={direct.name};isd=[direct.isdir];
    dirs=dirs(isd==1);
    set(handles.dirs_LB, 'Value', 1, 'String', dirs);
    %get file listing
    files=[];
    for i=1:length(handles.fmask)
        files=[files ; dir([handles.path '/' handles.fmask{i}])];
    end
    files={files.name};files=sort(files);
    %remove duplicate filenames (wrong mask?)
    i=1;l=length(files);
    while i<l
        j=i+1;
        while j<l
            if strcmp(files{i},files{j}),files(j)=[];l=l-1;
            else break;
            end
        end
        i=i+1;
    end
    set(handles.files_LB, 'Value', 1, 'String', files);
    %deactivate buttons
    if ~isempty(files)
        set(handles.ok_PB, 'Enable', 'on');
    else
        set(handles.ok_PB, 'Enable', 'off');
    end


function current_dir_ET_Callback(hObject, eventdata, handles)
    ndir = get(hObject,'String');
    if (exist(ndir,'dir')==7)
        handles.path=ndir;
        %get directory listing
        getdir(handles);
    end
    % Update handles structure
    guidata(hObject, handles);


