function varargout = glremoveproof_gui(varargin)
% GLREMOVEPROOF_GUI M-file for glremoveproof_gui.fig
%      GLREMOVEPROOF_GUI by itself, creates a new GLREMOVEPROOF_GUI or raises the
%      existing singleton*.
%
%      H = GLREMOVEPROOF_GUI returns the handle to a new GLREMOVEPROOF_GUI or the handle to
%      the existing singleton*.
%
%      GLREMOVEPROOF_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GLREMOVEPROOF_GUI.M with the given input arguments.
%
%      GLREMOVEPROOF_GUI('Property','Value',...) creates a new GLREMOVEPROOF_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before glremoveproof_gui_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to glremoveproof_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help glremoveproof_gui

% Last Modified by GUIDE v2.5 14-Dec-2009 20:01:01

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @glremoveproof_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @glremoveproof_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before glremoveproof_gui is made visible.
function glremoveproof_gui_OpeningFcn(hObject, eventdata, handles, varargin)
handles.path=[];
if nargin > 3
    for i=1:2:length(varargin)
        if strcmp(varargin{i},'Proofdir')
            %path supplied
            if exist(varargin{i+1},'dir')==7,
                handles.path=varargin{i+1};
            end
        end
    end
end
if isempty(handles.path),error('glremoveproof_gui: proof dir not supplied!');end
if exist([handles.path 'index.html'],'file')==2,
    %get proof listing
    fid = fopen([handles.path 'index.html'],'r');
    proofs=cell(0);in=0;
    while 1
        string=fgetl(fid);   % reads next line without line feed
        if ~ischar(string),
            %end of file reached
            break;
        elseif strcmp(string,'<!-- Problems begin -->'),
            %entered problem listing
            in=1;
        elseif strcmp(string,'<!-- Problems end -->'),
            %end of problem listing
            break;
        elseif in==1,
            %found a problem
            ind=find(string=='"');str=string((ind(1)+1):ind(2)-1);
            ind=find(str=='.');str=str(1:ind(end)-1);
            proofs=[proofs; {str}];
        end
    end
    fclose(fid);
    set(handles.proofs_LB, 'Value', 1, 'String', proofs);
    handles.output = [];
    guidata(hObject, handles);
    glsetguipos(hObject, 'ur', 'u-0.44', 'r-0.445');
    set(handles.figure1,'WindowStyle','modal')
    % UIWAIT makes glselecttask_gui wait for user response (see UIRESUME)
    uiwait(handles.figure1);
else
    h=warndlg('No proofs found!','No proofs to remove','modal');
    uiwait(h);
    handles.output = [];
    guidata(hObject, handles);
end
    
% --- Outputs from this function are returned to the command line.
function varargout = glremoveproof_gui_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.output;
guidata(hObject, handles);
delete(handles.figure1);

% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
if ~isfield(handles,'figure1')
    delete(hObject); return;
end

if isequal(get(handles.figure1, 'waitstatus'), 'waiting')
    uiresume(handles.figure1);
else
    delete(handles.figure1);
end
    
% --- Executes on key press over figure1 with no controls selected.
function figure1_KeyPressFcn(hObject, eventdata, handles)
uiresume(handles.figure1);

% --- Executes on button press in ok_PB.
function ok_PB_Callback(hObject, eventdata, handles)
    fnames=get(handles.proofs_LB, 'String');
    fname=fnames{get(handles.proofs_LB, 'Value')};
    handles.output = fname;
    guidata(hObject, handles);
    uiresume(handles.figure1);

% --- Executes on button press in cancel_PB.
function cancel_PB_Callback(hObject, eventdata, handles)
uiresume(handles.figure1);



% --- Executes during object deletion, before destroying properties.
function figure1_DeleteFcn(hObject, eventdata, handles)
glsaveguipos(hObject);
