function varargout = glsaveprob_gui(varargin)
% GLSAVEPROB_GUI M-file for glsaveprob_gui.fig
%      GLSAVEPROB_GUI by itself, creates a new GLSAVEPROB_GUI or raises the
%      existing singleton*.
%
%      H = GLSAVEPROB_GUI returns the handle to a new GLSAVEPROB_GUI or the handle to
%      the existing singleton*.
%
%      GLSAVEPROB_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GLSAVEPROB_GUI.M with the given input arguments.
%
%      GLSAVEPROB_GUI('Property','Value',...) creates a new GLSAVEPROB_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before glsaveprob_gui_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to glsaveprob_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help glsaveprob_gui

% Last Modified by GUIDE v2.5 14-Dec-2009 19:53:18

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @glsaveprob_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @glsaveprob_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before glsaveprob_gui is made visible.
function glsaveprob_gui_OpeningFcn(hObject, eventdata, handles, varargin)
P=[];strategy=[];
if nargin > 3
    for i=1:2:length(varargin)
        if strcmp(varargin{i},'Problem'), P=varargin{i+1};
        elseif strcmp(varargin{i},'Strategy'), strategy=varargin{i+1};
        end
    end
end
handles.P=P;
set(handles.filename_ET, 'String', P.name);
if ~isfield(P, 'xbox') || (all(isinf(P.xbox.inf)) && all(isinf(P.xbox.sup)))
    set(handles.save_box_CB, 'Value',0,'Enable', 'off');
end
if isempty(strategy), set(handles.save_strat_CB, 'Enable', 'off');
else handles.strategy=strategy;
end
handles.output = [];
guidata(hObject, handles);
% set the gui position
glsetguipos(hObject, 'ur', 'u-0.49', 'r-0.13');
set(handles.figure1,'WindowStyle','modal')
% UIWAIT makes glselecttask_gui wait for user response (see UIRESUME)
uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = glsaveprob_gui_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.output;
guidata(hObject, handles);
delete(handles.figure1);

% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)

if ~isfield(handles,'figure1')
    delete(hObject); return;
end

if isequal(get(handles.figure1, 'waitstatus'), 'waiting')
    uiresume(handles.figure1);
else
    delete(handles.figure1);
end
    
% --- Executes on key press over figure1 with no controls selected.
function figure1_KeyPressFcn(hObject, eventdata, handles)
uiresume(handles.figure1);

% --- Executes on button press in ok_PB.
function ok_PB_Callback(hObject, eventdata, handles)
global glconf;
fname=get(handles.filename_ET, 'String');
box=get(handles.save_box_CB, 'Value');
stra=get(handles.save_strat_CB, 'Value');
f='Yes';h='Yes';
%save problem
pfile=[fname '.glb'];
if exist(pfile,'file')==2,
    f = glsavedlg_gui([{'Problem file '};{pfile};...
                {'exists.'}]);
end
if strcmp(f,'Yes')
    P=handles.P;
    %set new name
    P.name=fname;
    %set description
    desc={['Gloptlab internal problem file,'...
        'saved by Gloptlab at ' date]};
    %unsimplify
    [P, P.xbox]=glunsimplify(P, P.xbox, 0);
    if ~box,
        %delete bound constraints
        nx=length(P.Q.int);
        P.xbox.inf=-inf+zeros(nx,1);P.xbox.sup=inf+zeros(nx,1);
        %delete found boxes & stack
        if isfield(P,'boxes'), P=rmfield(P,'boxes'); end
        if isfield(P,'bstack'), P=rmfield(P,'bstack');end
    else
        %dont delete bound constraints, additional description
        desc=[desc ; {'with additional bound constraint box'}];
    end
    %set history
    P.desc=[desc; {'Previous history:'}; P.desc];
    %set strategy
    if stra, P.stratname=handles.strategy.name;
    else P.stratname=[];
    end
    %save problem file
    save(pfile,'P');
    %save info file
    info=glprobinfo(P);
    glsave(info,[fname '.inf']);
end

%save strategy (optionally overwrite existing one)
if stra,
    sname=handles.strategy.name;
    sfile=[glconf.stratdir '/' sname '.str'];
    if exist(sfile,'file')==2,
        h = glsavedlg_gui([{'Strategy file '};{[sname '.str']};...
                {'exists.'}]);
    end
    if strcmp(h,'Yes')
        strategy=handles.strategy; %#ok<NASGU>
        save(sfile,'strategy');
    end
end
if strcmp(f,'Yes')
    handles.output = fname;
    guidata(hObject, handles);
    uiresume(handles.figure1);
end

% --- Executes on button press in cancel_PB.
function cancel_PB_Callback(hObject, eventdata, handles)
uiresume(handles.figure1);

% --- Executes during object deletion, before destroying properties.
function figure1_DeleteFcn(hObject, eventdata, handles)
glsaveguipos(hObject);
