function varargout = glselecttask_gui(varargin)
% GLSELECTTASK_GUI M-file for glselecttask_gui.fig
%      GLSELECTTASK_GUI by itself, creates a new GLSELECTTASK_GUI or raises the
%      existing singleton*.
%
%      H = GLSELECTTASK_GUI returns the handle to a new GLSELECTTASK_GUI or the handle to
%      the existing singleton*.
%
%      GLSELECTTASK_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GLSELECTTASK_GUI.M with the given input arguments.
%
%      GLSELECTTASK_GUI('Property','Value',...) creates a new GLSELECTTASK_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before glselecttask_gui_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to glselecttask_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help glselecttask_gui

% Last Modified by GUIDE v2.5 14-Dec-2009 19:03:54

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @glselecttask_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @glselecttask_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before glselecttask_gui is made visible.
function glselecttask_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to glselecttask_gui (see VARARGIN)
task=[];
if nargin > 3
    for i=1:2:length(varargin)
        if strcmp(varargin{i},'Task')
            task=varargin{i+1};
        end
    end
end
if ~isempty(task)
    if strcmp(task.name, 'Read Problem')
        handles.output = glreadprob_gui('Task', task);
    elseif strcmp(task.name, 'Simplify')
        handles.output = glsimplify_gui('Task', task);
    elseif strcmp(task.name, 'Propagate')
        handles.output = glpropagate_gui('Task', task);
    elseif strcmp(task.name, 'Ehull')
        handles.output = glehull_gui('Task', task);
    elseif strcmp(task.name, 'Linear')
        handles.output = gllinear_gui('Task', task);
    elseif strcmp(task.name, 'Conic')
        handles.output = glconic_gui('Task', task);
    elseif strcmp(task.name, 'Begin Probing')
        handles.output = glprobing_gui('Task', task);
    elseif strcmp(task.name, 'Begin Split')
        handles.output = glsplit_gui('Task', task);
    elseif strcmp(task.name, 'Merge')
        handles.output = glmerge_gui('Task', task);
    elseif strcmp(task.name, 'Begin While')
        handles.output = glwhile_gui('Task', task);
    elseif strcmp(task.name, 'Begin Condition')
        handles.output = glcondition_gui('Task', task);
    elseif strcmp(task.name, 'Project')
        handles.output = glproject_gui('Task', task);
    elseif strcmp(task.name, 'Feasibility')
        handles.output = glfeasibility_gui('Task', task);
    elseif strcmp(task.name, 'Custom')
        handles.output = glcustom_gui('Task', task);
    elseif strcmp(task.name, 'Break')
        handles.output = glbreak_gui('Task', task);
    else
        handles.output = [];
    end
    guidata(hObject, handles);
    delete(handles.figure1);
    return;
end
% set the gui position
glsetguipos(hObject, 'ur', 'u', 'r-0.015');
% Choose default command line output for glselecttask_gui
handles.output = [];
% Update handles structure
guidata(hObject, handles);
% Make the GUI modal
set(handles.figure1,'WindowStyle','modal')
% UIWAIT makes glselecttask_gui wait for user response (see UIRESUME)
uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = glselecttask_gui_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Get default command line output from handles structure
if isfield(handles,'output') 
    varargout{1} = handles.output;
    delete(handles.figure1);
else varargout{1} =[];
end

% --- Executes when user attempts to close glselecttask_gui.
function figure1_CloseRequestFcn(hObject, eventdata, handles)

if ~isfield(handles,'figure1')
    delete(hObject); return;
end
 
if isequal(get(handles.figure1, 'waitstatus'), 'waiting')
    % The GUI is still in UIWAIT, us UIRESUME
    uiresume(handles.figure1);
else
    % The GUI is no longer waiting, just close it    
    delete(handles.figure1);
end

% --- Executes on key press over glselecttask_gui with no controls selected.
function glselecttask_gui_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to glselecttask_gui (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Check for "enter" or "escape"
if isequal(get(hObject,'CurrentKey'),'escape')
    % User said no by hitting escape
    handles.output = 'Cancel';
    % Update handles structure
    guidata(hObject, handles);
    uiresume(handles.figure1);
end    
    
if isequal(get(hObject,'CurrentKey'),'return')
    uiresume(handles.figure1);
end    

% --- Executes on button press in simplify_PB.
function simplify_PB_Callback(hObject, eventdata, handles)
handles.output = glsimplify_gui;
guidata(hObject, handles);
uiresume(handles.figure1);

% --- Executes on button press in propagate_PB.
function propagate_PB_Callback(hObject, eventdata, handles)
handles.output = glpropagate_gui;
guidata(hObject, handles);
uiresume(handles.figure1);

% --- Executes on button press in ehull_PB.
function ehull_PB_Callback(hObject, eventdata, handles)
handles.output = glehull_gui;
guidata(hObject, handles);
uiresume(handles.figure1);

% --- Executes on button press in linear_PB.
function linear_PB_Callback(hObject, eventdata, handles)
handles.output = gllinear_gui;
guidata(hObject, handles);
uiresume(handles.figure1);

% --- Executes on button press in conic_PB.
function conic_PB_Callback(hObject, eventdata, handles)
handles.output = glconic_gui;
guidata(hObject, handles);
uiresume(handles.figure1);

% --- Executes on button press in project_PB.
function project_PB_Callback(hObject, eventdata, handles)
handles.output = glproject_gui;
guidata(hObject, handles);
uiresume(handles.figure1);

% --- Executes on button press in while_PB.
function while_PB_Callback(hObject, eventdata, handles)
handles.output = glwhile_gui;
guidata(hObject, handles);
uiresume(handles.figure1);

% --- Executes on button press in condition_PB.
function condition_PB_Callback(hObject, eventdata, handles)
handles.output = glcondition_gui;
guidata(hObject, handles);
uiresume(handles.figure1);

% --- Executes on button press in probing_PB.
function probing_PB_Callback(hObject, eventdata, handles)
handles.output = glprobing_gui;
guidata(hObject, handles);
uiresume(handles.figure1);

% --- Executes on button press in split_PB.
function split_PB_Callback(hObject, eventdata, handles)
handles.output = glsplit_gui;
guidata(hObject, handles);
uiresume(handles.figure1);

% --- Executes on button press in merge_boxes.
function merge_boxes_Callback(hObject, eventdata, handles)
handles.output = glmerge_gui;
guidata(hObject, handles);
uiresume(handles.figure1);

function pause_PB_Callback(hObject, eventdata, handles)
handles.output.name = 'Pause';
guidata(hObject, handles);
uiresume(handles.figure1);

% --- Executes on button press in break_PB.
function break_PB_Callback(hObject, eventdata, handles)
handles.output = glbreak_gui;
guidata(hObject, handles);
uiresume(handles.figure1);

% --- Executes on button press in postprocess_PB.
function postprocess_PB_Callback(hObject, eventdata, handles)
handles.output = glpostprocess_gui;
guidata(hObject, handles);
uiresume(handles.figure1);

% --- Executes on button press in locsol_PB.
function feas_PB_Callback(hObject, eventdata, handles)
handles.output = glfeasibility_gui;
guidata(hObject, handles);
uiresume(handles.figure1);

% --- Executes on button press in custom_PB.
function custom_PB_Callback(hObject, eventdata, handles)
handles.output = glcustom_gui;
guidata(hObject, handles);
uiresume(handles.figure1);

% --- Executes on button press in cancel_PB.
function cancel_PB_Callback(hObject, eventdata, handles)
handles.output = [];
guidata(hObject, handles);
uiresume(handles.figure1);

function figure1_DeleteFcn(hObject, eventdata, handles)
glsaveguipos(hObject);
