%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% glguiclick_callback.m %%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% glguiclick_callback(hObject, eventdata)
%
% Callback for the variable range textfields created in the 
% glplot_init function.
%
% hObject   the handle of the textbox
% eventdata event data (empty)

function glguiclick_callback(hObject, eventdata, text)

MAXC=35;
% parent=get(hObject,'Parent');
% get(hObject,'Tag')
% get(parent,'SelectionType')
if ~isempty(text)
    ind=find(text==':');
    if ~isempty(ind),title=text(1:ind(1)-1);text=text(ind(1)+1:end);
    else title='Help';
    end
    tn=length(text);
    if tn>MAXC
        spac=[find(text==' ') tn];
        txt=cell(0);i=1;
        while i<tn
            sp=find(spac<=i+MAXC);eind=min(i+MAXC,spac(sp(end)));
            txt=[txt;{text(i:eind)}];i=eind+1;
        end
    else txt={text};
    end
    % set the position relative to the component
    set(hObject,'Units','pixels');
    ppos=get(get(hObject,'Parent'),'Position');
    pos=get(hObject,'Position');
    bpos(3)=MAXC*7;bpos(4)=length(txt)*4+22;
    if pos(1)<ppos(3)/2
        bpos(1)=ppos(1)+pos(1)+pos(3)+1;
        bpos(2)=ppos(2)+pos(2)+pos(4)-bpos(4)-22;
    else
        bpos(1)=ppos(1)+pos(1)-bpos(3)-1;
        bpos(2)=ppos(2)+pos(2)+pos(4)-bpos(4)-22;
    end
    h = figure('NumberTitle', 'off', 'Name', title, 'Units', 'pixels',...
        'Position',bpos,'WindowStyle','modal');
    uicontrol('Parent',h,'Style', 'text', 'HorizontalAlignment', ...
        'left', 'String', text, 'Units', 'Normalized','Position',...
        [0,0,1,1], 'ButtonDownFcn', ['delete(' num2str(h,10) ')']);
    uiwait(h);
end