%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%% glsaveguipos.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% function [ posy, posx ] = glsaveguipos(fh)
%

function [ posy, posx ] = glsaveguipos(fh)

global glconf;    % global configuration variable

corner = glgetguipref(fh,'corner');
posx = glgetguipref(fh,'posx');
posy = glgetguipref(fh,'posy');

% if we can not determine corners/anchors, then return
if (isempty(corner) || isempty(posx) || isempty(posy))
    return;
end

% init
set(fh,'Units','pixels');
pos=get(fh,'Position');
x=pos(1);y=pos(2);w=pos(3);h=pos(4);
mpos=get(glconf.mainfig,'Position');
mx=mpos(1);my=mpos(2);mw=mpos(3);mh=mpos(4);

if corner(1)=='l', dh=0;
elseif corner(1)=='u', dh=h;
end
% compute the relative y coodinate
if posy(1)=='l', sy=(y+dh-my)/mh;
elseif posy(1)=='u', sy=(y+dh-my-mh)/mh;
end
posy = [posy(1) sprintf('%+1.4f',sy)];

if corner(2)=='l', dw=0;
elseif corner(2)=='r', dw=w;
end
% compute x coodinate and the width
if posx(1)=='l', sx=(x+dw-mx)/mw;
elseif posx(1)=='r', sx=(x+dw-mx-mw)/mw;
end
% there is one error: with glselecttask_gui, the right corner isnt computed 
% correctly. eg. glsetguipos(hObject,'ur','u-0.2','l+0.5'); yields a
% slightly different sx each invocation. i think its because the set width
% is smaller than the actual minimum width on my win 7 system. 
% confirmed, made the gui slightly wider and the bug is gone. - stephan
posx = [posx(1) sprintf('%+1.4f',sx)];

glsetguipref(fh,'posx',posx);
glsetguipref(fh,'posy',posy);
