%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%% glload.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% function var=glload(filen)
%
% loads a variable struct: constants, vectors, strings, and cell arrays
% and comments ( (varname)_comment = comment after the variable definition
% comment... comment line ) from a text file saved by glsave
%
% filen      input file with full path
%
% var        output varaible structure

function var=glload(filen)
if nargin<1, error('glload: not enough arguments!');end

if exist(filen,'file')==2,
    fid=fopen(filen);
    scell=cell(0);
    while 1
        tline = fgetl(fid);
        if ~ischar(tline), break, end
        scell=[scell; {tline}];
    end
    fclose(fid);
    var=glscell2struct(scell, struct);
else
    error(['glload: error opening ' filen ' !']);
end