%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%% glparsevars.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% function [ok,vind]=glparsevar(s,orig,all)
%
% parses a string representing variable indexes, of the format;
% n...m, or ,k and combnation of these the special strings 'all'
% and 'orig' return the supplied variables all and orig
% e.g. s='2..5,-3,-5..1' or s='all' all indexes greater than all(end)
% and less than all(1) will be deleted
%
% s     string to parse  
% orig  orig index (optional) returns if s='orig'
% all   all index (optional) returns if s='all'

function [ok,vind]=glparsevar(s,orig,all)

%argcechk
if nargin <1
    error('glparsevars: Not enough arguments!');
end

ok=1;i=1;vind=[];max=length(s);
if strcmp(s,'orig')
    if nargin>1,vind=orig;
    else vind='orig';
    end;
elseif strcmp(s,'all')
    if nargin>2,vind=all;
    else vind='all';
    end;
else
    while i<=max
        ch=s(i);n=str2num(ch);
        if ~isempty(n) || ch=='-'
            %numeric value at char pos found
            j=i;n=1;
            while ~isempty(n)
                j=j+1;if j>max,break;end
                n=str2num(s(j));
            end
            n1=str2num(s(i:j-1));
            if j<=max,
                if s(j)==',' || s(j)==' '
                    vind=[vind n1];i=j+1;
                elseif s(j)=='.' || s(j)==':'
                    %find second number
                    while isempty(n) && s(j)~='-',
                        j=j+1;
                        if j>max,ok=0;return;end
                        n=str2num(s(j));
                    end
                    i=j;
                    while ~isempty(n) || s(j)=='-',
                        j=j+1;if j>max,break;end
                        n=str2num(s(j));
                    end
                    n2=str2num(s(i:j-1));
                    if n1<=n2
                        vind=[vind n1:n2];i=j;
                    else
                        ok=0;return;
                    end
                else
                    ok=0;
                    return;
                end
            else
                vind=[vind n1];i=j;
            end
        elseif s(i)==',' || s(i)==' '
            i=i+1;
        else
            ok=0;return;
        end

    end
    %remove 0 entries
    vind=vind(vind~=0);
end
if nargin == 3
    %delete all indexes > all(end) && < all(1) && zeros
    vind=vind(vind<=all(end) & vind>=all(1) & vind~=0);
end