%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%% glsave.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% function glsave(var, filen)
%
% saves a variable struct: constants, vectors, strings, and cell arrays
% and comments ( (varname)_comment = comment after the variable definition
% comment... comment line ) to a text filen readable by glload
%
% var        varaible structure of which the fields will be saved
% filen      output filen with full path

function glsave(var, filen)

%argcheck
if nargin < 2
    error('glsave: not enough arguments!');
end
strc=glstruct2scell(var);
fid=fopen(filen,'w');
if fid == -1, error(['glsave: Filename wrong:' filen]); end
for i=1:length(strc)
    fprintf(fid,'%c',strc{i});
    fprintf(fid,'\n');
end
fclose(fid);