%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% glremoveproof.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function glremoveproof(probname, proofdir)
% removes the proof for the problem file
%
% probname  name of the problem
% proofdir      directory in which the proofs are located  

function glremoveproof(probname, proofdir)

%argcheck
if nargin <2, error('glremoveproof: Not enough arguments!');end

if exist(proofdir,'dir') == 7 && ...
        exist([proofdir probname '.html'],'file')==2,
    delete([proofdir probname '*']);
    %remove problem entry from the index
    fid = fopen([proofdir 'index.html'],'r');out='';in=0;
    while 1
        string=fgetl(fid);   % reads next line without line feed 
        if ~ischar(string),
            %end of file reached
            break;
        elseif strcmp(string,'<!-- Problems begin -->')
            %entered problem listing
            in=1;
        elseif in==1 && ~isempty(findstr(string,probname))
            %index found, jump to next, do not write
            continue;
        end
        out=[out string '\n'];
    end
    fclose(fid);
    %rewrite the index file
    fid = fopen([proofdir 'index.html'],'w');
    fprintf(fid,out);
    fclose(fid);
end