%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% glsavesol.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% function glsavesol(s, fname)
%
% saves a solution to a file
%
% s          solution structure (see glsol2str)
% filen      solput file with full path

function glsavesol(s, fname)

%argcechk
if nargin <2
    error('glsavesol: Not enough arguments!');
end

%comments
sol.comment1='%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%';
sol.comment2='%%%%%%%%%%%%%%% GLOPTLAB SOLUTION FILE %%%%%%%%%%%%%%%';
sol.comment3='%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%';
sol.comment4='%';
sol.comment5=['% ' upper(s.probname)];    
sol.comment6='%-----------------------------------------------------';
str=glsol2str(s);
for i=1:length(str)
    sol.(['comment' num2str(i+6)])=['% ' str{i}];
end
sol.(['comment' num2str(length(str)+7)])=...
        '%-----------------------------------------------------';
sol.(['comment' num2str(length(str)+8)])='';
%solution data
fields=fieldnames(s);
for i=1:length(fields), sol.(fields{i})=s.(fields{i}); end
glsave(sol, fname);
