%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% glrange.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%function [range,gaps]=glrange(P, xbox, prt)
%
% computes range of the given Problem using forward propagation without
% concatenating with the original Fbox
%
% P         problem definition
% xbox      bound constraints
% prt       text output flag       0 = no output 1 = output
%
% range     range of the constraints
% gaps      gaps in the range

function [range,gaps]=glrange(P, xbox, prt)

% argcechk
if nargin <2
    error('glrange: Not enough arguments!');
end
if nargin<3,prt=0;end

range=glred(P.Q.A, xbox, [], prt);
gaps=[];

%****************OLD SEPARABLE*****************
% rigorous quadratic enclosure for nonquadratic basis functions   
%P.Q.Bu=gluniq(P,xbox);
% make separable structure
%sep=glsepq(P.Q, xbox, 'a', prt);
% rigorous constraint propagation on separable quadratics
%[xbox, range, gaps]=glqsred(sep, xbox, P.Q.F, -1, prt);