%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% glunsimplify.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function [P, x]=glunsimplify(P, x, prt)
%
% unsimplifyes the problem P by removing slacks and restoring the objective
%
% P         problem definition
% x         bound constraints
% prt       text output flag       0 = no output 1 = output
%
% P         new problem definition
% x         new bound constraints

function [P, x]=glunsimplify(P, x, prt)

% argcechk
if nargin <2, error('glunsimplify: Not enough arguments!'); end
if nargin <3, prt=0; end %#ok<NASGU>

if isfield(P.Q,'obj'),
    % restore the objective function
    P.Q.A.inf=[P.Q.A.inf; P.Q.obj.inf];P.Q.A.sup=[P.Q.A.sup; P.Q.obj.sup];
    P.Q.F.inf=[P.Q.F.inf; -inf];P.Q.F.sup=[P.Q.F.sup; inf];
    % set new objective index
    P.opt=size(P.Q.A.inf,1);
    % remove objective field
    P.Q = rmfield(P.Q, 'obj');
end