%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% glmat2scell.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% function ce=glmat2scell(A, prec)
%
% converts matrix to string cell array
%
% A     a matrix
% prec  precision of the numbers in the output (optional)
% 
% ce    string cell array created from the matrix

function ce=glmat2scell(A, prec)

% argcheck
if nargin<1, error('glmat2cell: Not enough arguments!');end
if nargin<2, prec=3;end
if isfield(A,'inf')
    % interval matrix
    isint=1;
    [n,m]=size(A.inf);
else
    % normal matrix
    isint=0;
    [n,m]=size(A);
end

ce=cell(n,1);
for j=1:m
    ml=1;val=cell(n,1);
    for i=1:n,
        if isint
            val{i}=[ '['...
                sprintf(['%0.' num2str(prec) 'g'],A.inf(i,j)) ' '...
                sprintf(['%0.' num2str(prec) 'g'],A.sup(i,j)) ']'];
        else val{i}=sprintf(['%0.' num2str(prec) 'g'],A(i,j));
        end
        ml=max(ml,length(val{i}));
    end
    ml=ml+2;
    for i=1:n
        ce{i}=[ce{i} val{i} char(32+zeros(1,ml-length(val{i})))];
    end
end
for i=1:n, ce{i}=['[' ce{i}(1:end-2) ']'];end

