%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% glstatus2str.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% function str=glstatus2str(status)
%
% converts a solution to a string cell
%
% status        = 0 Normal termination
%               = 1 stop the strategy (pause or user break)
%               = 2 break this tasklist (glbreak->break tasklist, infeas)
%               = 3 break the multiline (glbreak->break multiline)
%               = 4 continue with postprocess (glbreak->postprocess,timeout)
%               = 5 finish the strategy (glbreak->finish strategy, problem 
%                   not accepted: dim too high/nonquadratic found, after 
%                   postprocess)
%
% str           status string

function str=glstatus2str(status)

%argcechk
if nargin <1, error('glstatus2str: Not enough arguments!'); end

switch status
    case  0,str='Normal termination';
    case  1,str='Strategy paused';
    case  2,str='Break tasklist command found';
    case  3,str='Break multiline command found';
    case  4,str='Postprocess command found';
    case  5,str='Finish strategy command found';
    otherwise 
        gldisp('status',status);
        error('glstatus2str: unknown status!');
end