%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%% glwav2gls.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% function glwav2gls(fname);
%
% Convert a .wav file to a .gls file. The output file is stored in the
% sound directory.
%
% fname     file name of the wav file, in the sound directory or with full
%           path. If no filename is given it converts all wavs in the
%           sound directory.
%

function glwav2gls(fname)

sounddir=[fileparts(which('Gloptlab.m')) '/Sound/'];

if nargin==1
    % convert a file
    % check imput
    if exist(fname,'file')~=2,
        fname=[sounddir fname];
        if exist(fname,'file')~=2, error('glwav2gls: file not found!'); end
    end
    % read the .wav
    [y,Fs,bits] = wavread(fname); %#ok<NASGU>
    % save the .gls
    [path,name] = fileparts(fname);out=[sounddir name '.gls'];
    save(out, 'y', 'Fs', 'bits', '-MAT');
    disp([fname ' --> ' out]);
else
    % convert all files in the sound dir
    direct=dir(sounddir);
    files={direct.name};isd=[direct.isdir];
    files=files(isd==0);
    nams=cell(0);
    for i=1:length(files)
        [path,name,ext] = fileparts(files{i});
        if strcmp(ext,'.wav'), nams=[nams;{name}]; end
    end
    for i=1:length(nams)
        in=[sounddir nams{i} '.wav'];out=[sounddir nams{i} '.gls'];
        % read the .wav
        [y,Fs,bits] = wavread(in); %#ok<NASGU>
        % save the .gls
        save(out, 'y', 'Fs', 'bits', '-MAT');
        disp([in ' --> ' out]);
    end
end