#!/usr/bin/env perl
use File::Basename;

#
# Perl script for ampl2dag conversion (used for windows)
#

if ( $#ARGV < 2 ) {
  print "Usage: $0 <ampl-file> <ampl2daghome-dir> <ampl-dir> [<ampl options>]\n";
  exit 1;
}

$FILE=$ARGV[0];
$AMPL2DAGHOME=$ARGV[1];
$AMPL=$ARGV[2];
$NL2DAG="nl2dag";
$INFO2DAG="$AMPL2DAGHOME/info2dag";
$ENV{'PATH'} .= ":$AMPL2DAGHOME";

#print "*file:$FILE, home:$AMPL2DAGHOME, ampl: $AMPL \n";

if ( basename($FILE,()) ne basename($FILE, (".mod"))) {
  $FILEBASE=dirname($FILE)."/".basename($FILE, (".mod"));
  shift @ARGV;shift @ARGV;shift @ARGV;
  $AMPLARGS=join(" ", @ARGV)." -og$FILEBASE";
}

if ( basename($FILE,()) ne basename($FILE, (".run"))) {
  $STU="stub";
  $FILEBASE=dirname($FILE)."/".basename($FILE, (".run"));
  $STUBBASE=dirname($FILE)."/".$STU;
  $AMPLARGS="";
}

$TMPFILE="$FILEBASE.tmp";
print "option auxfiles 'acfrsuv';\n" > $TMPFILE;
$ENV{"OPTIONS_IN"}="$TMPFILE";

$cmd="$AMPL $AMPLARGS $FILE"; system($cmd);

if ( $? != 0 ) {
  print "Error using ampl to convert $FILE to non-linear format\n";
  exit 2;
}

if ( basename($FILE,()) ne basename($FILE, (".run"))) {
  if ( -f "$STUBBASE.nl" ) { rename "$STUBBASE.nl", "$FILEBASE.nl"; } 
  if ( -f "$STUBBASE.row" ) { rename "$STUBBASE.row", "$FILEBASE.row"; } 
  if ( -f "$STUBBASE.col" ) { rename "$STUBBASE.col", "$FILEBASE.col"; } 
  if ( -f "$STUBBASE.fix" ) { rename "$STUBBASE.fix", "$FILEBASE.fix"; } 
  if ( -f "$STUBBASE.unv" ) { rename "$STUBBASE.unv", "$FILEBASE.unv"; } 
  if ( -f "$STUBBASE.adj" ) { rename "$STUBBASE.adj", "$FILEBASE.adj"; } 
  if ( -f "$STUBBASE.slc" ) { rename "$STUBBASE.slc", "$FILEBASE.slc"; } 
}

if ( ! -f "$FILEBASE.nl" ) {
  print "Could not find ampl-generated non-linear format file.\n";
  exit 3;
}

$cmd="$NL2DAG $FILEBASE.nl > $FILEBASE.dag";system($cmd);

if ( $? != 0 ) {
  print "Error converting non-linear format to dag";
  exit 3;
}

$cmd="perl $INFO2DAG $FILEBASE >> $FILEBASE.dag";
system($cmd);

if ( -f $TMPFILE ) { unlink "$TMPFILE"; }

print "***********************************************\n";
print "* File $FILEBASE.dag was created successfully *\n";
print "***********************************************\n";

### Xuan-Ha VU
unlink "$FILEBASE.nl";
unlink "$FILEBASE.row";
unlink "$FILEBASE.col";
unlink "$FILEBASE.fix";
unlink "$FILEBASE.unv";
unlink "$FILEBASE.adj";
unlink "$FILEBASE.slc";
unlink "$FILEBASE.tmp";
### Xuan-Ha VU

