%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% glcompmat.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% function res=glcompmat(A)
% 
% compute the comparison matrix of A
%
% A             interval matrix
%   .inf.sup    bounds
% C             comparison matrix

function C=glcompmat(A)

% argcheck
if nargin<1, error('glcompmat: Not enough arguments!');end

% init
[m,n]=size(A.inf);
if m~=n, error('Comparison matrix only for square matrices');end

% compute the comparison matrix of A
C=-glmag(A);
d.inf=diag(A.inf);d.sup=diag(A.sup);
C(1:n+1:n*n)=glmig(d);

