%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% glmig.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% function mig=glmig(x)
% 
% compute the mignitude of a box
%
% x             box
%   .inf.sup    bounds
% mig           mignitude of x

function mig=glmig(x)

% argcheck
if nargin <1, error('glmig: Not enough arguments!');end
% init
[m,n]=size(x.inf); mig=zeros(m,n);
% compute mignitude
for i=1:m
    for j=1:n
        if x.inf(i,j)>0, mig(i,j)=x.inf(i,j);
        elseif x.sup(i,j)<0, mig(i)=-x.sup(i,j);
        end
    end
end