%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% glrand.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% function z=glrand(x, ind)
% 
% create a random point inside of the given box x.
%
% x         box
%   .inf    nx x 1 lower bounds
%   .sup    nx x 1 upper bounds
%
% z         nx x 1 point inside of x

function z=glrand(x)

% argcheck
if nargin <1, error('glrand: Not enough arguments!');end
nx=length(x.inf);

% compute a naive random point in the box
z=random(nx,1).*(x.sup-x.inf)+x.inf;

% reset the infinite components
ind1=(x.inf==-inf);ind2=(x.sup==inf);
ninf=ind1&~ind2;pinf=ind2&~ind1;
z(ind1&ind2)=0;z(ninf)=x.sup(ninf);z(pinf)=x.inf(pinf);