%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% glerrorlog.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% function glerrorlog(err)
%
% Log an error in the error log file. The logfile is in the Gloptlab main
% directory and is named errorlog.txt.
%
% err      string or string cell of the error

function glerrorlog(err)

% argchek
if nargin <1, error('glerrorlog: Not enough arguments!');end

% logfile location
errorlog=[fileparts(which('Gloptlab.m')) filesep 'errorlog.txt'];

% append new log entry
fid = fopen(errorlog,'a+');
fprintf(fid,'%s\n',['----------------------' datestr(now)...
    '--------------------------']);
if ~iscell(err)
    fprintf(fid,'%s\n',err);
else
    for i=1:length(err)
        fprintf(fid,'%s\n',err{i});
    end
end
fclose(fid);
