%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% glfindstr.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% function ind=glfindstr(scell,str,field)
%
% finds the string in a cell of strings and returns the found index set
%
% scell     cell array of strings to search in
% str       string to find in scell{i}
% field     optional string representing the field of the cell
%           array to search in
%
% ind       found index set which can be empty if no matches found

function ind=glfindstr(scell,str,field)
%argcheck
if nargin <2, error('glfindstr: Not enough arguments!');
elseif nargin ==2
    ind=[];
    for i=1:length(scell)
        if strfind(scell{i},str)
            ind=[ind i];
        end
    end
else
    ind=[];
    for i=1:length(scell)
        if strfind(scell{i}.(field),str)
            ind=[ind i];
        end
    end
end
