%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% glnewer.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function newer = glnewer(fname1, fname2)
%
% compares to files and determines which of them is newer, if none of the
% two files exist an error message is generated.
% info: under linux newer=unix(['[ ' fname1 ' -nt ' fname2 ' ]']);
%
% fname1, fname2    file names (existing or not)
% 
% newer             =1: file1 is newer than file 2

function newer = glnewer(fname1, fname2)

if exist(fname1,'file')==2 && exist(fname2,'file')==2
    f1=dir(fname1);f2=dir(fname2);
    if datenum(datevec(f1.date))>datenum(datevec(f2.date)), newer=1;
    else newer=0;
    end
elseif exist(fname1,'file')==2, newer=1;
elseif exist(fname2,'file')==2, newer=0;
else error('glnewer: both filenames are non existent!');
end
