function outfile = glreplaceinfile(tplfile, tokens, replaces, targetfile)
%outfile = replaceinfile(tplfile, tokens, replaces)
%replaces tokens{i} by replaces{i} in file tplfile and writes to a file
%named tplfile w/o the .tpl extension in (optional) outputdir
   
    [pathstr, name, ext, versn] = fileparts(tplfile);
    
    if ~isempty(pathstr)
        outfile = [pathstr,filesep,targetfile]; % same dir    
    else
        outfile = [pwd,filesep,targetfile];
    end
    fprintf('Writing file "%s" to "%s"',tplfile,outfile);    

    fid=fopen(tplfile,'r');
    s = fread(fid, '*char')';
    for i=1:length(tokens),
        s = strrep(s,tokens{i},replaces{i});
    end
    fclose(fid);
       
    fid=fopen(outfile,'w'); 
    fprintf(fid,escapeString(s));
    fclose(fid);
    
end

function str = escapeString(str)
    str = strrep(str,'%','%%');
    str = strrep(str,'\','\\');
    str = strrep(str,'''','''''');    
end
