%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%% glsound.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% function glsound(type);
%
% play a sound of the type.
%
% types: start      - Gloptlab start
%        error      - error
%        criterror  - critical error
%        break      - strategy interrupted by the user
%        pause      - strategy paused
%        tfinish    - task finished
%        pfinish    - problem finished
%        exit       - Gloptlab exit
%

function glsound(type)

if nargin<1, error('glsound: not enough arguments!'); end;

% get the filename
sounddir=[fileparts(which('Gloptlab.m')) '/Source/Sound/'];
fname=[sounddir 'gl' type '.gls'];
if exist(fname,'file')~=2, 
    disp(['* ERROR * Sound file: ' fname ' not found!']);
    return;
end
% play  sound
s = load(fname, '-MAT');
sound(s.y,s.Fs,s.bits);

